<?php
namespace Pinpoint\CheckoutCharacterLimit\Helper;

use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Store\Model\ScopeInterface;

class Config extends AbstractHelper
{
    const XML_PATH_CHARACTER_LIMIT = 'checkout_character_limit/fields/';

    /**
     * Get character limit for a specific field
     *
     * @param string $fieldCode
     * @param null|int $storeId
     * @return int|null
     */
    public function getCharacterLimit($fieldCode, $storeId = null)
    {
        return $this->scopeConfig->getValue(
            self::XML_PATH_CHARACTER_LIMIT . $fieldCode,
            ScopeInterface::SCOPE_STORE,
            $storeId
        );
    }
}
