<?php
namespace Pinpoint\CheckoutCharacterLimit\Plugin\Block;

use Pinpoint\CheckoutCharacterLimit\Helper\Config;
use Magento\Checkout\Block\Checkout\LayoutProcessorInterface;

class LayoutProcessor
{
    protected $configHelper;

    public function __construct(
        Config $configHelper
    ) {
        $this->configHelper = $configHelper;
    }

    public function afterProcess(
        LayoutProcessorInterface $subject,
        array $jsLayout
    ) {
        $characterLimitFirstName = $this->configHelper->getCharacterLimit('first_name');
        $characterLimitLastName = $this->configHelper->getCharacterLimit('last_name');
        $characterLimitCompanyName = $this->configHelper->getCharacterLimit('company_name');
        $characterLimitStreetAddress = $this->configHelper->getCharacterLimit('street_address');
        $characterLimitCity = $this->configHelper->getCharacterLimit('city');
        $characterLimitRegion = $this->configHelper->getCharacterLimit('region');

        // Apply character limits to the checkout fields
        $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']
        ['shippingAddress']['children']['shipping-address-fieldset']['children']['firstname']['validation']['max_text_length'] = $characterLimitFirstName;

        $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']
        ['shippingAddress']['children']['shipping-address-fieldset']['children']['lastname']['validation']['max_text_length'] = $characterLimitLastName;

        $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']
        ['shippingAddress']['children']['shipping-address-fieldset']['children']['company']['validation']['max_text_length'] = $characterLimitCompanyName;

        $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']
        ['shippingAddress']['children']['shipping-address-fieldset']
        ['children']['street']['children'][0]['validation']['max_text_length'] = $characterLimitStreetAddress;
        $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']
        ['shippingAddress']['children']['shipping-address-fieldset']
        ['children']['street']['children'][1]['validation']['max_text_length'] = $characterLimitStreetAddress;
        $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']
        ['shippingAddress']['children']['shipping-address-fieldset']
        ['children']['street']['children'][2]['validation']['max_text_length'] = $characterLimitStreetAddress;

        $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']
        ['shippingAddress']['children']['shipping-address-fieldset']['children']['city']['validation']['max_text_length'] = $characterLimitCity;

        $jsLayout['components']['checkout']['children']['steps']['children']['shipping-step']['children']
        ['shippingAddress']['children']['shipping-address-fieldset']['children']['region']['validation']['max_text_length'] = $characterLimitRegion;

        return $jsLayout;
    }
}
