# Magento 2 Checkout Character Limit Module

This custom Magento 2 module allows you to set dynamic character limits for various checkout fields from the admin panel. It provides flexibility in managing character limits without the need to modify code.

## Features

- Set character limits for the following checkout fields:
    - First Name
    - Last Name
    - Company Name
    - Street Address (each line)
    - City
    - Region

## Admin Configuration

Configure character limits easily from the admin panel under Stores > Configuration > Pinpoint > Checkout Character Limits.

## Installation

### Type 1: Zip file

- Unzip the zip file in `app/code/Pinpoint`
- Enable the module by running `php bin/magento module:enable Pinpoint_CheckoutCharacterLimit`
- Apply database updates by running `php bin/magento setup:upgrade`\*
- Flush the cache by running `php bin/magento cache:flush`

### Type 2: Composer

- Install the module composer by running `composer require pinpoint/module-checkout-character-limit`
- Enable the module by running `php bin/magento module:enable Pinpoint_OneTrust`
- Apply database updates by running `php bin/magento setup:upgrade`\*
- Flush the cache by running `php bin/magento cache:flush`


